<?php
/**
 * MultiCopy.
 *
 * @package     virtUOS
 * @subpackage  administration
 *
 * @author    aklassen
 * @copyright (c) Authors
 * @version   $Id$
 */

class MultiCopy extends AbstractStudIPAdministrationPlugin {



  function MultiCopy() {

    parent::AbstractStudIPAdministrationPlugin();

    $this->setPluginiconname("img/plugin.png");

    # navigation
    $navigation =& new PluginNavigation();
    $navigation->setDisplayname(_("Kopieren von mehreren Veranstaltungen"));
    $this->setNavigation($navigation);


    ## AbstractStudIPAdministrationPlugin specifics

    # top navigation
    $top_navigation =& new PluginNavigation();
    $top_navigation->setDisplayname(_("MultiCopy"));

   
    $this->setTopnavigation($top_navigation);
  }


  function initialize() {
    }


  function getPluginname() {
    return _("MultiCopy");
  }

	
  function actionShow() {

 	global $ASSETS_URL, $perm, $user_inst_array, $fvs_data;

	// alle modi variablen umbiegen...
	$modus = $_REQUEST['modus'];
	$modus_x = $_REQUEST['modus_x'];
	$modus2 = $_REQUEST['modus2'];
	$modus2_x = $_REQUEST['modus2_x'];
	$modus3 = $_REQUEST['modus3'];
	$modus3_x = $_REQUEST['modus3_x'];
	$modus4 = $_REQUEST['modus4'];
	
	$sem = $_REQUEST['sem'];
	$category = $_REQUEST['category'];
	$show_sem_tree = $_REQUEST['show_sem_tree'];
	$subselects = $_REQUEST['subselects'];
	$act_sem = $_REQUEST['act_sem'];
	$my_cat = $_REQUEST['my_cat'];
	$subselects2 = $_REQUEST['subselects2'];
	$info_checkbox = $_REQUEST['info_checkbox'];
	$sem_cp = $_REQUEST['sem_cp'];
	$cp_sem_button_x = $_REQUEST['cp_sem_button_x'];
	$check = $_REQUEST['check'];
	

	$user = $GLOBALS['user']; 
	session_register("fvs_data");

	$out = "";
	$csv = "";

	$perm->check("admin");
	if (!isset($sem)) {
		$info_checkbox=1;
	}
	?>
	<script language="JavaScript">
	function checkAll(elm,name){
	    for (var i = 0; i < document.cp_mult.elements.length; i++) {
	        if (document.cp_mult.elements[i].name.indexOf(name) == 0)
	            document.cp_mult.elements[i].checked = true;
	    }
	}

	function uncheckAll(elm,name){
	    for (var i = 0; i < document.cp_mult.elements.length; i++) {
	        if (document.cp_mult.elements[i].name.indexOf(name) == 0)
	            document.cp_mult.elements[i].checked = false;
	    }
	}

	</script>
	<?
	if (isset($modus2_x)) {
		$fvs_data["sem"] = $sem;
		$fvs_data["category"] = $category;
		$fvs_data["show_sem_tree"] = $show_sem_tree;
		$fvs_data["modus"] = $modus;
		$fvs_data["modus2"] = $modus2;
		$fvs_data["modus3"] = $modus3;
		$fvs_data["subselects"] = $subselects;
		$fvs_data["subselects2"] = $subselects2;
		$fvs_data["modus2_x"] = $modus2_x;
		$fvs_data["info_checkbox"] = $info_checkbox;
	}
	if ($modus4=="move_up" || $modus4=="move_down") {
		$sem = $fvs_data["sem"];
		$category = $fvs_data["category"];
		$modus2 = $fvs_data["modus2"];
		$modus3 = $fvs_data["modus3"];
		$subselects = $fvs_data["subselects"];
		$subselects2 = $fvs_data["subselects2"];
		$modus2_x = $fvs_data["modus2_x"];
		$show_sem_tree = $fvs_data["show_sem_tree"];
		$info_checkbox = $fvs_data["info_checkbox"];
	}
	require_once(dirname(__FILE__)."/admin_copy_mult.inc.php");
	//include ("seminar_open.php"); // initialise Stud.IP-Session
	require_once("lib/classes/SemesterData.class.php");
	require_once("lib/classes/HolidayData.class.php");
	require_once('lib/classes/StudipAdmissionGroup.class.php');

	if (!$perm->have_perm("root")) {
	        $user_inst_array = array();
	        $user_inst_array = get_admin_user_inst($user->id);
	}
	if ($modus2!="go_sem_new_window") {
	//	include ("html_head.inc.php"); // Output of html head
	//	include ("header.php");   // Output of Stud.IP head
	} else {
		ob_start();
		?>
		<html>
			<head><title>Alle Veranstaltungen</title></head>
			<body>
		
	<?	
	}

	require_once ("lib/dates.inc.php");   // Output of Stud.IP head
	require_once ("lib/msg.inc.php"); //Funktionen fuer Nachrichtenmeldungen
	require_once ("lib/visual.inc.php");


	$cssSw=new cssClassSwitcher;

	if ($modus2!="go_sem_new_window") {
	if ($cp_sem_button_x) {
	    $_border = 0;
	} else {
	    $_border = 1;
	}

	} 

	$db=new DB_Seminar;
	$semObject = new SemesterData;
	if (!isset($sem)) {
		$semdata = $semObject->getCurrentSemesterData(); 
		$sem = $semdata["semester_id"];
	}
	$semester = show_all_semester($semObject,$sem);
	$categories = get_categories(5,$db);
	$s_categories = show_select_categories($categories,10,$category);

	if (isset($modus2_x) && (!isset($subselects))) { // Oberkategorie ausgewhlt und Veranstaltungen anzeigen
		$subselects2 = $category;
		$modus = "go_sem";
		$show = "no_kat";
	}
	elseif (isset($modus2_x) && (!isset($subselects2))) {	//erste Unterkategorie ausgewhlt und alles anzeigen!
		$subselects2 = $subselects;
		$modus = "go_sem";
		$show = "one_kat";
	}
	elseif ($category=="") {
		unset($modus);
	}
	elseif (isset($category) && (!is_array($categories[$category]["sub"]))) {
		unset($modus);
	}
	elseif (isset($subselects) && (!is_array($categories[$category]["sub"][$subselects]["sub"]))) {
		$modus = "go_fb";
		$modus_x=1;
	}

	if ($cp_sem_button_x){
	        // ab hier wird die Import-/Exportroutine benutzt...
	        $i=0;
	        $cp_sem_array = array();    // Array mit zu kopierenden Daten
	        $deny_sem_array = array();      // Array mit nicht zu kopierenden Daten
	        foreach ($check as $key => $val) {
	            if (strlen($val)>10) {
	                $cp_sem_array[] = $val;
	            }
	        }
	        $cp_sem_array = array_unique($cp_sem_array);        // ganz wichtig, um zu vermeiden, dass Veranstaltungen doppelt kopiert werden
	        sort($cp_sem_array);

	        // es duerfen nur Veranstaltungen kopiert werden, in denen der Benutzer admin der Heimateinrichtung ist, root darf alle
	        if (!$perm->have_perm("root")) {
	            $tmp_array = check_seminars($cp_sem_array, $user->id);
	            $cp_sem_array = $tmp_array[0];      // zu kopierende Veranstaltungen
	            $deny_sem_array = $tmp_array[1];    // nicht zu kopierende Veranstaltungen
	        } 

	        $sem_count = count ($cp_sem_array);
	        include($path = (dirname(__FILE__)."/multicopy/import_config.inc.php"));
	        $config = new MultiCopyConfig;
	        $_sem = new SemesterData;       // wir brauchen die neue Startzeit der Veranstaltung...
	        $_sem_cp = $_sem->getSemesterData($sem_cp);
	        $config->STARTTIME = $_sem_cp["beginn"];    // hier die config-Variable neu setzen
	
	        $u_reader = new UniReader($config, $cp_sem_array);   // Instanz des Uni-Readers, Konstruktor mit Array bestehend aus Seminar_ids
	        $u_reader->setAllSeminars();                // alle Seminare werden in den StorageVector gepackt
			
					// Beim kopieren wurden die metadate_ids mit bernommen was zu Uberschneidungen und Problemen fhrte.
					foreach ($u_reader->storage_vector->storage_array as $key => $data) {
						$md = unserialize($data->seminar['metadata_dates']);
						foreach ($md['turnus_data'] as $num => $turnus) {
							$md['turnus_data'][$num]['metadate_id'] = md5(uniqid(rand()));
						}
						$u_reader->storage_vector->storage_array[$key]->seminar['metadata_dates'] = serialize($md);
					}
			
	        $u_writer = new UniWriter($config, $u_reader->storage_vector);
	        $msg = $u_writer->initWrite();
	        
	        
	      
	        if($_REQUEST['admission_group']) {
			
				
				$group_obj = new StudipAdmissionGroup();

				
				
				// add all new Seminars to a group

				foreach ($u_reader->storage_vector->storage_array as $val) {
	                $group_obj->addMember($val->getSeminarId());
				}
				
					
				
				$group_obj->setValue('name', trim(stripslashes($_REQUEST['admission_group_name'])));
				
				// store the new group
				if($group_obj->store()){
				$info = _("Bitte beachten Sie, dass Sie die gruppierten Anmeldeverfahren noch 
					   konfigurieren mssen (Teilnehmerzahl, Anmeldezeitraum, etc.).");
				}
				
			}
	        
	        
	        
	        
			
			if ($msg) {
				require_once('lib/msg.inc.php'); 		// Funktionen fuer Nachrichtenmeldungen
				parse_msg($msg);
			}
			
	        if ($sem_count > 0) {
		
		?>
	            <tr>
					<td colspan=2 class=blank valign=center>
						<img src=" <?=$GLOBALS['ASSETS_URL']?>images/ok.gif" border=0>&nbsp;
						<font color=green><?= $sem_count ?> Veranstaltung(en) wurde(n) erfolgreich in das <?=$_sem_cp["name"]?> kopiert:</font>
						<? if ($info != '') : ?>
						<font color=green><?=$info?></font>
						<? endif;?>
					</td>
				</tr>
				<tr><td>&nbsp;</td></tr>
				<?
					// Logging //
                    $cp_sem_string = '';
                    $cp_sem_string_info = '';
	            foreach ($u_reader->storage_vector->storage_array as $key => $val) {
	                $name = get_seminar_name($val->getSeminarId());
	                $nummer = get_va_nummer($val->getSeminarId());
					?>
				<tr>
					<td width="10%" class=blank>
						<font size=2><a href="<?=URLHelper::getlink('adminarea_start.php', array('select_sem_id'=> $val->getSeminarId()))?>"><em><?=$nummer?></em></a></font> 
					</td>
					<td class=blank>
						<font size=2><a href="<?=URLHelper::getlink('adminarea_start.php', array('select_sem_id'=> $val->getSeminarId()))?>"><em><?=$name?></em></a></font>
					</td>
				</tr>
					<?
				    $cp_sem_string .= $name.", ";
	                $cp_sem_string_info .= $val->seminar['Seminar_id']."--->".$name.", ";
	            }
	        }
	        if (count($deny_sem_array)>0) {
	            ?>
				<tr>
					<td colspan=2 class=blank valign=center>
						<img src="<?=$GLOBALS['ASSETS_URL']?>images/x.gif" border=0>&nbsp;
						<font color=red><?=count($deny_sem_array)?> Veranstaltung(en) konnte(n) nicht kopiert werden (keine Berechtigung):</font>
					</td>
				</tr>
				<tr><td>&nbsp;</td></tr>
				<?
				    foreach ($deny_sem_array as $key => $val) {
	                $name = get_seminar_name($val);
	                $nummer = get_va_nummer($val);
	                $fb_name = get_institute($val);
	?>
				<tr>
					<td width="10%" class=blank>
						<font size=2><em><?=$nummer?></em></font>
					</td>
					<td class=blank>
						<font size=2><em><?=$name?></em>&nbsp;&nbsp;&nbsp;
							<b>Heimateinrichtung:&nbsp;<?=$fb_name?></b>
						</font>
					</td>
				</tr>
					<?
	            }
	        }
			?>
			<tr><td>&nbsp;</td></tr>
	        	<tr>
					<td class="blank" colspan=2>
						<a href="<?=PluginEngine::getLink($this,array(),"show")?>"><em>zur&uuml;ck</em></a>
					</td>
				</tr>
			<?
				
	        $cp_sem_string = rtrim($cp_sem_string, ", ");
	        $cp_sem_string_info = rtrim($cp_sem_string_info, ", ");

	        log_event("SEM_COPY_MULT",NULL,NULL,$cp_sem_string,$cp_sem_string_info);

	} elseif ($modus=="go_fb" && isset($modus_x)) {	// erste Unterkategorie
		
		?>
				<tr>
					<td width="20%" class="blank"> 	
						<?=make_form($PHP_SELF)?>
						Semester:<br><?=$semester?>
					</td>
					<td colspan=4 class="blank" width="80%">
					</td>
				</tr>
				<tr>
					<td class="blank" width="20%" valign="top">
						Oberkategorien:<br><?=$s_categories?>
						<?=create_sem_tree_checkbox($show_sem_tree)?>
						<?=create_info_checkbox($info_checkbox)?>
					</td>
					<td width="5%" class="blank" align="center" valign="middle">
						<?=make_image_button("go_fb","right")?>
					</td>
					<td width="20%" class="blank" valign="top">
						<? $subs = show_sub_selected_categories($categories[$category]["sub"],10,"",0);?>
						Unterkategorien:<br><?=$subs?>
					</td>
					<td class="blank">
						<?=make_image_button("go_fb2","right")?>
					</td>
				</tr>
				<tr>
					<td align="center" class="blank" colspan=5>
	        			<table>
							<tr>
								<td class=blank>
									<?=make_image_button("go_sem","down")?>	
	        					</td>
								<td class=blank>
									<a href="<?=PluginEngine::getLink($this,array(),"show")?>"><?=makeButton("zuruecksetzen")?></a>
	        					</td>
							</tr>
						</table>
						<?=make_end_form()?>
					</td>
				</tr>
			<?
				
	} elseif (($modus3=="go_fb2") && isset($modus3_x)) {	// weitere Unterkategorien
			?>
			
			<tr>
				<td width="20%" class="blank">	
					<?=make_form($PHP_SELF)?>
					Semester:<br><?=$semester?>
				</td>
				<td colspan=4 class="blank" width="80%">
				</td>
			</tr>
			<tr>
				<td class="blank" width="20%" valign="top">
					Oberkategorien:<br>
					<?=$s_categories?>
					<?=create_sem_tree_checkbox($show_sem_tree)?>
					<?=create_info_checkbox($info_checkbox)?>
				</td>
				<td width="5%" class="blank" align="center" valign="middle">
					<?=make_image_button("go_fb","right")?>
				</td>
				<td width="20%" class="blank" valign="top">
				
				<?$subs = show_sub_selected_categories($categories[$category]["sub"],10,$subselects,0);?>	
			
					Unterkategorien:<br>
					<?=$subs?>
				</td>
				<td class="blank" width="5%" align="center">
					<?=make_image_button("go_fb2","right")?>	
				</td>
				<td class="blank" valign="top">
					weitere Unterkategorien:<br>
			
			<? $sub2 = show_sub_selected_categories($categories[$category]["sub"][$subselects]["sub"],10,"",3,"subselects2")?>
			
					<?=$sub2?>
				</td>
			</tr>
			<tr>
				<td align="center" class="blank" colspan=5>
	        		<table>
						<tr>
							<td class=blank>
								<?=make_image_button("go_sem","down")?>	
	        				</td>
							<td class=blank>
								<a href="<?=PluginEngine::getLink($this,array(),"show")?>"><?=makeButton("zuruecksetzen")?></a>
	        				</td>
						</tr>
					</table>
					<?=make_end_form()?>
				</td>
			</tr>
			<?
		} elseif (($modus2=="go_sem") && isset($modus2_x)) {	// zeige alles an
			?>
			
			<tr>
				<td width="20%" class="blank">	
					<?=make_form($PHP_SELF)?>
					Semester:<br> <?=$semester ?>
				</td>
				<td colspan=4 class="blank" width="80%">
				</td>
			</tr>
			<tr>
				<td class="blank" valign="top">
					Oberkategorien:<br><?= $s_categories?>
					<?= create_sem_tree_checkbox($show_sem_tree)?>
					<?=create_info_checkbox($info_checkbox) ?>
				</td>
				<td width="5%" class="blank" align="center" valign="middle">
					<?= make_image_button("go_fb","right")?>
				</td>
				<td width="20%" class="blank" valign="top">
			<?if ($show=="no_kat") // nicht die Unterkategorien 
			{ ?>								
				<td width="70%" colspan=3 class="blank"></td>
			<?} elseif ($show=="one_kat") {					// nur die erste Unterkategorie
				$subs = show_sub_selected_categories($categories[$category]["sub"],10,$subselects,0); ?>	
					Unterkategorien:<br> <?= $subs ?>
				</td>
				<td class="blank" width="5%" align="center">
				<?= make_image_button("go_fb2","right")?>	
				</td>
				<td width="60%" class="blank">
				</td>

			<?} else	{					// zeige alles
				$subs = show_sub_selected_categories($categories[$category]["sub"],10,$subselects,0);	
				?>
					Unterkategorien:<br> <?= $subs?>
				</td>
				<td class="blank" width="5%" align="center">
					<?=make_image_button("go_fb2","right")?>	
				</td>
				<td class="blank" valign="top">
					weitere Unterkategorien:<br>
			<? 
				$sub2 = show_sub_selected_categories($categories[$category]["sub"][$subselects]["sub"],10,$subselects2,3,"subselects2");?>
			
				<?=  $sub2?>
			<?} ?>
				</td>
			</tr>
			<tr>
				<td align="center" class="blank" colspan=5>
	        		<table>
						<tr>
							<td class=blank>
								<?=makeButton("anzeigen")?>
	       					</td>
							<td class=blank>
								<a href="<?=PluginEngine::getLink($this,array(),"show")?>"><?=makeButton("zuruecksetzen")?></a>
	        				</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="blank" colspan=5>
			
			<? $all_cats = make_cats_together($subselects2,$db);
			$act_semester = get_semester_by_id($sem); ?>
			
					<table width="100%">
					</table>
					<table width="100%" cellspacing=0 cellpadding=2>
						<tr>
							</th><th align="left">Nummer</th>
							<th align="left">Name</th>
							<th align="left">Typ</th>
							<th align="left">Dozent</th>
							<th></th>
						</tr>
	        <? $checkbox_count=0; ?>
			
			<?= show_cats_with_seminars($all_cats,$db,"",$act_semester["beginn"],"",$show_sem_tree, $info_checkbox)?> 
					</table>	
				</td>
			</tr>
		    <tr><td>&nbsp;</td></tr>
		    </table>
		    <div style="padding-left:25%; padding-top:5px">
		    <fieldset style="width:50%; padding:5px">
		    <legend><?=_('Whlen Sie die gewnschten Optionen bezglich der gewhlten Veranstaltungen')?></legend>    
		    <table cellspacing="0" cellpadding="10" align="center" border="0">
		        <tr>
    		        <td align=center>
    					<a href="javascript:checkAll(this,'check')"><img src="<?=$ASSETS_URL?>images/locale/de/LC_BUTTONS/alleauswaehlen-button.png" border=0></a>&nbsp;&nbsp;
    					<a href="javascript:uncheckAll(this,'check')"><img src="<?=$ASSETS_URL?>images/locale/de/LC_BUTTONS/alleloeschen-button.png" border=0></a>
    				</td>
    			</tr>
		        <tr>
    				<td>
    	        		<?=_('In folgendes Semester kopieren')?>:&nbsp;<?=show_all_semester($semObject,$sem,"sem_cp",1)?>
    				</td>
    	        <tr>
    			<tr>	
    	       	    <td align="left">
    	       		    <?=_('Markierte Veranstaltungen in ein gruppiertes Anmeldeverfahren bertragen')?>: <input type=checkbox name="admission_group" value="true">
    	       		</td>
    			</tr>
    			<td align="left">
    	       		    <?=_('Name der neuen Gruppierung')?>: <input type=text name="admission_group_name" size=20>
    	       		</td>
    			<tr>
    			</tr>
    			<tr>
    				<td>
    	        	    <input type=image name="cp_sem_button" src="<?=$ASSETS_URL?>images/locale/de/LC_BUTTONS/ok-button.png">
    	        	</td>
    			</tr>
			</table>
	        </fieldset>
	        </div>
			<table>
		<?=make_end_form()?>
	 <?	} elseif ($modus2=="go_sem_new_window") { 
			$all_cats = make_cats_together($my_cat,$db);
			$act_semester = get_semester_by_id($act_sem); ?>
			<table width="100%" cellspacing=0 cellpadding=2>
				<tr>
					<td class="blank">
						<table width="100%" cellspacing=0 cellpadding=2>
							<tr>
								<th align="left">Nummer</th>
								<th align="left">Name</th>
								<th align="left">Raum</th>
								<th align="left">Typ</th>
								<th align="left">Dozent</th>
							</tr>
			<? if ($csv_export) {
				$csv = show_cats_with_seminars($all_cats,$db,"",$act_semester["beginn"],"",$show_sem_tree,$info_checkbox,0,true);
			} else { ?>
				<?= show_cats_with_seminars($all_cats,$db,"",$act_semester["beginn"],"",$show_sem_tree,$info_checkbox,0,false)?><?
			} ?>
						</table>
					</td>
				</tr>
	       </table>

		<? } else {		// default ?>
				<tr>
					<td width="20%" class="blank"> 	
						<?=make_form($PHP_SELF)?>
						Semester:<br><?= $semester?>
					</td>
					<td colspan=4 class="blank" width="80%">
					</td>
				</tr>
				<tr>
					<td class="blank">
						Oberkategorien:<br> <?= $s_categories?> 
						<?=create_sem_tree_checkbox($show_sem_tree)?>
						<?=create_info_checkbox($info_checkbox)?>
					</td>
					<td width="80%" class="blank" align="left" valign="middle">
						<?=make_image_button("go_fb","right")?>
					</td>
				</tr>
				<tr>
					<td align="center" valign="center" class="blank" colspan=5>
	       				<table>
							<tr>
								<td>
									<?= makeButton("anzeigen") ?>
	  							</td>
								<td>
									<a href="<?=PluginEngine::getLink($this,array(),"show")?>"><?=makeButton("zuruecksetzen")?></a>
	        					</td>
							</tr>
						</table>
	 					<?=make_end_form()?>
					</td>
				</tr>
			<?
				$out = ob_get_contents();
				ob_end_clean();
		}

	echo $out;


	page_close(NULL);

  }


  function actionShowAdministrationPage() {
  }
}
