<?
//require_once("semester_seminar_order.inc.php");


if($GLOBALS["SOFTWARE_VERSION"] == "Stud.IP 1.1.5-OS-1"){
	require_once("language.inc.php");	
	}
	else {
		require_once("lib/language.inc.php");
	}






//
// Erzeuge array mit allen Top-Level-Kategorien und
// untergeordneten Kategorien bis Ebene $level
//
function get_categories($level,$db) {
	$db2 = new DB_Seminar;
	$sql = "SELECT * FROM sem_tree s LEFT JOIN Institute i ON s.studip_object_id=i.Institut_id WHERE s.parent_id='root'";
	$db->query($sql);
	while ($db->next_record()) {
		$data[$db->f("sem_tree_id")]["name"] = $db->f("Name");
		if (!$data[$db->f("sem_tree_id")]["name"]) {
			$data[$db->f("sem_tree_id")]["name"] = $db->f("name");
		}
		$data[$db->f("sem_tree_id")]["info"] = $db->f("info");
		$data[$db->f("sem_tree_id")]["sub"] = get_sub_categories($level,$db2,$db->f("sem_tree_id"));
	}
	return $data;
}

function get_seminar_name($seminar_id) {
    $db = new DB_Seminar;
    $sql =  "SELECT Name FROM seminare ".
            "WHERE Seminar_id = '".$seminar_id."'";
    $db->query($sql);
    $db->next_record();
    return $db->f("Name");
}

function get_va_nummer($seminar_id) {
    $db = new DB_Seminar;
    $sql =  "SELECT VeranstaltungsNummer FROM seminare ".
            "WHERE Seminar_id = '".$seminar_id."'";
    $db->query($sql);
    $db->next_record();
    return $db->f("VeranstaltungsNummer");
}



//
// Erzeuge HTML-Select-Box mit den bergebenen Kategorien
//
function show_select_categories($categories,$size,$selected="") {
	$data = "<select name=\"category\" size=\"".$size."\" style=\"width: 250px\">";
	while (list($key,$val)=each($categories)) {
			$data .= "<option value=\"".$key."\"";
			if ($key==$selected) {
				$data .= " SELECTED ";
			}
			$data .=">".$val["name"]."</option>\n";
			if (is_array($val["sub"])) {
				$offset = "&nbsp;&nbsp;";
				//$data .= show_sub_select_categories($val["sub"],$offset);
			}
	}
	$data .= "</select>";
	return $data;
}

//
// Erzeuge HTML-Formular-Kopf
//
function make_form($target) {
	$form = "<form name=\"cp_mult\" action=\"".$target."\" METHOD=\"POST\">";
	return $form;
}

//
// Erzeuge HTML-Formular-Ende
//
function make_end_form() {
	$form = "</form>";
	return $form;
}

//
// Erzeuge SELECT-Feld fr untergeordnete Kategorien
//
function show_sub_selected_categories($s_categories,$size,$selected="",$depth,$f_name="subselects") {
	$data = "<select name=\"".$f_name."\" size=\"".$size."\" style=\"width: 250px\" >";
	$data .= show_sub_select_categories($s_categories,"",$selected,$depth);
	$data .= "</select>";
	return $data;
}

//
// Hilfsfunktion: Enzeleintrge erzeugen
//
function show_sub_select_categories($s_categories,$offset="",$selected="",$depth) {
	while (list($key,$val)=each($s_categories)) {
		$data .= "<option value=\"".$key."\"";
		if ($selected==$key) {
			$data .= " SELECTED ";
		}
		$data .= ">".$offset.$val["name"]."</option></b>";
		if (is_array($val["sub"]) && ($depth>=1)) {
			//$depth--;
			$data .= show_sub_select_categories($val["sub"],$offset."&nbsp;&nbsp;",$selected,$depth);
		}
	}
	return $data;
}

//
// Checkbox fr sem_tree-Eintrage erzeugen
//

function create_sem_tree_checkbox($sem_tree) {
	return $data;
}

function create_info_checkbox($info_checkbox) {
	return $data;
}

function get_admin_user_inst($user_id) {
    $user_inst_array = array();
    $db = new DB_Seminar;
    $sql =  "SELECT Institut_id FROM user_inst ".
            "WHERE user_id = '".$user_id."' AND inst_perms='admin'";
    $db->query($sql);
    while ($db->next_record()) {
        $user_inst_array[] = $db->f("Institut_id");
    }
    return $user_inst_array;
}

function show_cats_with_seminars($categories,$db,$offset,$start,$cats="",$show_sem_tree="", $info_checkbox="", $show_arrow=1, $csv_export = false) {
	global $SEM_TYPE;
    global $checkbox_count;
    global $perm;           // ugh...
    global $user;
    global $user_inst_array;

	$nl = "\n";

	$db6 = new DB_Seminar;
	$sql = "SELECT semester_id FROM semester_data WHERE beginn='".$start."'";
	$db6->query($sql);
	$db6->next_record();
	$semester_id = $db6->f("semester_id");
	while (list($key,$val)=each($categories)) {
		

		/// optimized for versions < 4.0.21 >>
		$sql = "SELECT 
						s.teilnehmer, s.Seminar_id, s.Name, s.VeranstaltungsNummer, 
						s.status, s.Untertitel as Untertitel
				FROM 
						seminare s LEFT JOIN seminar_sem_tree ss ON (s.Seminar_id=ss.seminar_id)
						LEFT JOIN semester_data sd ON(s.start_time = sd.beginn)
				WHERE  
						ss.sem_tree_id='".$key."' AND 
						sd.semester_id='".$semester_id."' 
				ORDER BY 
							s.VeranstaltungsNummer";
		/// << optimized for versions < 4.0.21
		$db3 = new DB_Seminar;
		$db3->query($sql);
		// Kategorieberschrift
		//
		$count_rows = $db3->num_rows();
		//echo $val["info"]."<br/>";
		//$csv .= "<cat>".strip_tags(str_replace("\n", "", str_replace("&nbsp;", "", $cats))).str_replace("\n", "" , $val["name"])."</cat>".$nl;
		if ($count_rows || ($val["info"] && $info_checkbox)){
			$data .= "<tr>";
			$data .= "<td colspan=6 valign=top style=\"border-top:thin solid\"><font size=-1><b>".$cats.$val["name"]."</b></font></td>";
			$data .= "</tr>";
			if ($val["info"] && $info_checkbox) {
				$data .= "<tr>";
				$data .= "<td colspan=6 valign=top align=\"center\"><table bgcolor=\"#f5f5f5\"width=\"90%\" cellpadding=5 cellspacing=2><tr><td><font size=\"-1\">".formatReady($val["info"])."</font></td></tr></table><br></td>";
				$data .= "</tr>";
			}
		}

		// Einzeleintrge
		//
		while ($db3->next_record()) {
            $has_perms = 0;
			$db4 = new DB_Seminar;
			$sql4 = "SELECT a.Nachname,a.Vorname FROM seminar_user LEFT JOIN auth_user_md5 a USING (user_id) WHERE Seminar_id='".$db3->f("Seminar_id")."' AND status='dozent'";
			$db4->query($sql4);
			$db5 = new DB_Seminar;
			$sql = "SELECT content FROM datafields_entries WHERE datafield_id='8d94e6a5277b8b279d4216be4800e570' AND range_id='".$db3->f("Seminar_id")."'";
			$db5->query($sql);
			$db5->next_record();
			$style = " style=\"border-top:thin solid\" ";
			$data .= "<tr>";
            // duerfen wir ueberhaupt kopieren?
            if (!$perm->have_perm("root")) {
                $db7 = new DB_Seminar;
                $sql7 =  "SELECT i.Institut_id, i.fakultaets_id, i.Name FROM seminare s ".
                    "LEFT JOIN Institute i ON s.Institut_id=i.Institut_id ".
                    "WHERE Seminar_id = '".$db3->f("Seminar_id")."'";
                $db7->query($sql7);
                $db7->next_record();
                $i_id = $db7->f("Institut_id");
                $f_id = $db7->f("fakultaets_id");
                foreach ($user_inst_array as $key2 => $val2) {
                    if (($i_id === $val2) || ($f_id === $val2)) {
                        $has_perms++;
                    }
                }
            } else {
                $has_perms++;
            }
            if (!$has_perms) {
                $_color = " color=grey ";
                $_comment = "<tr><td>&nbsp;</td><td colspan=4><font size=-1 color=red><em>Nur der Administrator der Heimateinrichtung (".$db7->f("Name").") kann diese Veranstaltung kopieren</em></font></td></tr>";
            } else {
                $_color = "";
                $_comment = "";
            }
			$data .= "<td valign=top ".$style.">";
			$data .= "<font size=-1 ".$_color.">".$db3->f("VeranstaltungsNummer")."&nbsp;</font>";
			$data .= "</td>";
			$data .= "<td valign=top ".$style.">";
			$data .= "<font size=-1 ".$_color.">".
				     "<a href=\"". URLHelper::getlink('seminar_main.php', array('auswahl'=> $db3->f("Seminar_id"))).
				     "\">" . $db3->f("Name")."</a></font>";
			if ($show_sem_tree) {
				$path = get_sem_tree_path($db3->f("Seminar_id"));
			}
			$data .= "</td><td valign=top ".$style."><font size=-1 ".$_color.">";
			$data .= $SEM_TYPE[$db3->f("status")]["name"];
			$data .= "</td><td valign=top ".$style."><font size=-1 ".$_color.">";
			$csv .= "<dozent>";
			while ($db4->next_record()) {
				if ($db4->f("Vorname")) {
					$csv .= "!".$db4->f("Nachname").", ".$db4->f("Vorname")." ";
					$data .= $db4->f("Nachname").", ".$db4->f("Vorname")."<br>";
				} else {
					$csv .= "!".$db4->f("Nachname")." ";
					$data .= $db4->f("Nachname")."<br>";
				}
			}
			$data .= "</font></td>";
            if ($has_perms) {
                $data .= "<td valign=top ".$style."><input type=\"CHECKBOX\" name=\"check[".$checkbox_count."]\" value=\"".$db3->f("Seminar_id")."\"";
                $data .= "></td>\n";
            } else {
                $data .= "<td valign=top ".$style.">&nbsp;</td>";
            }
            $checkbox_count++;
            $data .= "</tr>";
			if ($db3->f("teilnehmer") || $db5->f("content")) {
				$data .= "<tr><td>&nbsp;</td><td colspan=4>";
				$data .= "<font size=-1 ".$_color."><em>";
				$data .= $db3->f("teilnehmer");
				if ($db3->f("teilnehmer") && $db5->f("content")) {
					$data .= ",&nbsp;";
				}
				$data .= $db5->f("content");
				$data .= "&nbsp;</em></font>";
                $data .= "</td>";
				$data .= "</tr>\n";
			}
            $data .= $_comment;

			if ($path) {
				foreach($path as $sem_tree_id => $path_name) {
					$data .= "<tr>";
					$data .= "<td>&nbsp;</td>";
					$data .= "<td colspan=4><font size=-1><li>".htmlReady($path_name)."</li></font></td>";
					$data .= "</tr>";
				}
			}
			$position++;
		}

		if ($csv_export) {
			echo ":";
			flush();
		}

		if (is_array($val["sub"])) {
			$cats_new = $cats.$val["name"]."&nbsp;>&nbsp;";
			if (!$csv_export) {
				$data .= show_cats_with_seminars($val["sub"],$db,$offset."&nbsp;&nbsp;",$start,$cats_new,$show_sem_tree, $info_checkbox,$show_arrow, false);
			} else {
				$csv .= show_cats_with_seminars($val["sub"],$db,$offset."&nbsp;&nbsp;",$start,$cats_new,$show_sem_tree, $info_checkbox,$show_arrow, true).$nl;
			}
		}
	}

	if ($csv_export) {
		echo ".";
		flush();
		return $csv;
	} else {
		return $data;
	}
}

function get_institute($seminar_id) {
    $db = new DB_Seminar;
    $sql =  "SELECT i.Name as Name FROM seminare s ".
        "LEFT JOIN Institute i ON s.Institut_id=i.Institut_id ".
        "WHERE Seminar_id = '".$seminar_id."'";
    $db->query($sql);
    $db->next_record();
    return $db->f("Name");
}

function make_cats_together($category,$db) {
	$sql = "SELECT * FROM sem_tree WHERE sem_tree_id = '".$category."'";
	$db->query($sql);
	$db->next_record();
	if (!$db->f("name")) {
		$data[$db->f("sem_tree_id")]["sub"] = get_all_down_categories($db->f("sem_tree_id"),$db);
		$sql = "SELECT Name FROM Institute WHERE Institut_id = '".$db->f("studip_object_id")."'";
		$db2 = new DB_Seminar;
		$db2->query($sql);
		$db2->next_record();
		$data[$db->f("sem_tree_id")]["name"] = $db2->f("Name");
	} else {
		$data[$db->f("sem_tree_id")]["name"] = $db->f("name");
		$data[$db->f("sem_tree_id")]["info"] = $db->f("info");
		$data[$db->f("sem_tree_id")]["sub"] = get_all_down_categories($db->f("sem_tree_id"),$db);
	}
	return $data;
}

function get_all_down_categories($id,$db) {
	$sql = "SELECT * FROM sem_tree WHERE parent_id='".$id."' ORDER BY priority";
	$db->query($sql);
	while ($db->next_record()) {
		$db2 = new DB_Seminar;
		$data[$db->f("sem_tree_id")]["name"] = $db->f("name");
		$data[$db->f("sem_tree_id")]["info"] = $db->f("info");
		$data[$db->f("sem_tree_id")]["sub"] = get_all_down_categories($db->f("sem_tree_id"),$db2);
	}
	return $data;
}

function make_image_button($modus,$pic) {
	switch ($modus) {
		case "go_fb":
			$mod = "modus";
			break;
		case "go_sem":
			$mod = "modus2";
			break;
		case "go_fb2":
			$mod = "modus3";
			break;
	}

	switch ($pic) {
		case "right":
			$but = "move_right.gif";
			$button .= "<input type=\"image\" name=\"".$mod."\" src=\"".$GLOBALS['ASSETS_URL'] . 'images/' . $but."\">";
			break;
		case "down":
			$but = "anzeigen-button.gif";
			$button .= makeButton("anzeigen", "input", "", $mod);
			break;
	}

	$button .= "<input type=\"hidden\" name=\"".$mod."\" value=\"".$modus."\">";
	return $button;
}

function get_sub_categories($level,$db,$id) {
	$level--;
	$sql = "SELECT * FROM sem_tree s WHERE parent_id='".$id."' ORDER BY priority";
	$db->query($sql);
	while ($db->next_record()) {
		$data[$db->f("sem_tree_id")]["name"] = $db->f("name");
		$data[$db->f("sem_tree_id")]["info"] = $db->f("info");
		if ($level>0) {
			$db3 = new DB_Seminar;
			$data[$db->f("sem_tree_id")]["sub"] = get_sub_categories($level,$db3,$db->f("sem_tree_id"));
		}
	}
	return $data;
}

//
// Konstruiere Auswahlbox mit allen Semestern
//
function show_all_semester($semObject,$selected="",$selectname="",$cut_old=0) {
	$all_semesters = $semObject->getAllSemesterData();
    $current_sem   = $semObject->getCurrentSemesterData();
    if ($cut_old) {
        foreach ($all_semesters as $key => $val) {
            if ($val["beginn"] >= $current_sem["beginn"]) {
                $cutted_sem[] = $val;
            }
        }
        $all_semesters = $cutted_sem;
    }
    if ($selectname=="") {
	    $data = "<select name=\"sem\">";
    } else {
	    $data = "<select name=\"".$selectname."\">";
    }
	for ($i=0;$i<count($all_semesters);$i++) {
		$data .= "<option value=\"".$all_semesters[$i]["semester_id"]."\"";
		if ($all_semesters[$i]["semester_id"]==$selected) {
			$data .= " SELECTED ";
		}
		$data .= ">".$all_semesters[$i]["name"]."</option>\n";
	}
	$data .= "</select>";
	return $data;
}

//
// Liefere komplettes Semesterfeld fr gegebene ID (md5)
//
function get_semester_by_id($sem_id) {
	$semObj = new SemesterData;
	$all_semester = $semObj->getAllSemesterData();
	for ($i=0;$i<count($all_semester);$i++) {
		if ($all_semester[$i]["semester_id"]==$sem_id) {
			$j=$i;
		}
	}
	return $all_semester[$j];
}

//
// Konstruiert einen Abschick-Button
//
function make_button($value,$name) {
	return "<input type=\"submit\" value=\"".$value."\" name=\"".$name."\">";
}

//
//  Sucht die Veranstaltungen raus, die nicht kopiert werden drfen und gibt diese als assoz Array zurck
//
function check_seminars($seminars, $user) {
    $db = new DB_Seminar;
    $sql =  "SELECT Institut_id ".
            "FROM user_inst ".
            "WHERE user_id = '".$user."' AND inst_perms = 'admin'";
    $db->query($sql);
    while ($db->next_record()) {
        $user_inst_admin[] = $db->f("Institut_id");
    }
    foreach ($seminars as $key => $val) {
        $has_perms = 0;
        $sql =  "SELECT i.Institut_id, i.fakultaets_id FROM seminare s ".
                "LEFT JOIN Institute i ON s.Institut_id=i.Institut_id ".
                "WHERE Seminar_id = '".$val."'";
        $db->query($sql);
        $db->next_record();
        $i_id = $db->f("Institut_id");
        $f_id = $db->f("fakultaets_id");
        foreach ($user_inst_admin as $key2 => $val2) {
            if (($i_id === $val2) || ($f_id === $val2)) {
                $has_perms++;
            }
        }
        if (!$has_perms) {
            $sem_array[1][] = $val;             // diese Veranstaltung darf nicht kopiert werden
        } else {
            $sem_array[0][] = $val;             // diese schon
        }
    }
    return $sem_array;
}

?>
