<?
/**
* UniWriter.class.php
* 
* 
*
* @author		Mark Sievers <msievers@uos.de> 
* @version		$Id: FHStudipWriter.class.php,v 1.1 2004/02/18 10:52:10 msievers Exp $
* @access		public
* @modulegroup	core
* @module			
* @package		studip_core
*/

// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// UniWriter.class.php
// This class gets a storageVector and writes it into the db
// Copyright (C) 2004 Mark Sievers <mark_sievers2000@yahoo.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

class UniWriter extends Writer {
    
    var $storage_array;
    var $current_sem_id;


    function UniWriter(&$config, $storage_vector) {
    	$this->config = $config;
        parent::Writer();
        $this->storage_vector = $storage_vector;
    }

    function setSeminar($seminar) {
        
       
	    $sql_key_string = "("; 
        $sql_val_string = "(";
        foreach ($seminar as $key => $val) {
            $sql_key_string .= $key.","; 
            $sql_val_string .= "'".addslashes($val)."',";
        }
        $sql_key_string = substr($sql_key_string,0,strlen($sql_key_string)-1);
        $sql_val_string = substr($sql_val_string,0,strlen($sql_val_string)-1);
        $sql_key_string .= ")";
        $sql_val_string .= ")";
        $sql =  "INSERT INTO seminare ".
                $sql_key_string.
                " VALUES ".
                $sql_val_string;
		$db = DBManager::get();
		//var_dump(); die;
		return $db->exec($sql);
    }

    function setSeminarSemTree($sem_tree) {
		$i = count($sem_tree);
		foreach ($sem_tree as $key => $val) {
			
            $sql =  "INSERT INTO seminar_sem_tree ".
                    "(sem_tree_id,seminar_id) ".
                    "VALUES ".
                    "('".$val["sem_tree_id"]."','".$this->current_sem_id."')";
			$db = DBManager::get();	
			$j += $db->exec($sql);
        }
		if ($i==$j) return 1;
		else return 0;
    }

    function setDozenten($dozenten) {
		$i = count($dozenten);
        foreach ($dozenten as $key => $val) {
            $sql =  "INSERT INTO seminar_user ".
                    "(Seminar_id,user_id,position,status) ".
                    "VALUES ".
                    "('".$this->current_sem_id."','".$val["id"]."',".$val["position"].",'dozent')";
			$db = DBManager::get();	
			$j += $db->exec($sql);
        }
		if ($i==$j) return 1;
		else return 0;
    }

    function setSeminarInst($seminar_insts) {
		$i = count($seminar_insts);
		foreach($seminar_insts as $seminar_inst)
		{
			$sql =  "INSERT INTO seminar_inst ".
				"(seminar_id,institut_id) ".
				"VALUES ".
				"('".$this->current_sem_id."','".$seminar_inst."')";
			$db = DBManager::get();	
			$j += $db->exec($sql);
		}
		if ($i==$j) return 1;
		else return 0;
    }

	
    function setGeneric($d_fields) {
		$db = DBManager::get();

        $sql_key_string = "(range_id,"; 
        $sql_val_string = "('".$this->current_sem_id."',";
        foreach ($d_fields as $key => $val) {
            $sql_key_string .= $key.","; 
            $sql_val_string .= "'".addslashes($val)."',";
			
		}
        $sql_key_string = substr($sql_key_string,0,strlen($sql_key_string)-1);
		$sql_val_string = substr($sql_val_string,0,strlen($sql_val_string)-1);
        $sql_key_string .= ")";
        $sql_val_string .= ")";
		
	
        $sql =  "INSERT INTO datafields_entries ".
                $sql_key_string.
                " VALUES ".
                $sql_val_string;

		return $db->exec($sql);

    }


	


    function getSemesterId($beginn) {
		$db = DBManager::get();
		$sql =  "SELECT semester_id ".
	            "FROM semester_data ".
	            "WHERE beginn=? LIMIT 1";

		$st = $db->prepare($sql);
		$st->execute(array($beginn));
		$row = $st->fetch();

		return $row['semester_id'];
    }

		function initWrite() {


			// fuer das Eintragen in die semester_seminar_order-Tabelle brauchen wir noch die ID des Semesters
			$semester_id = $this->getSemesterId($this->config->STARTTIME);
			foreach ($this->storage_vector->storage_array as $key => $val) {
				$new_semid = $val->seminar['Seminar_id'];
				$this->current_sem_id = $val->getSeminarId();
				if(!$this->setSeminar($val->seminar)==1) 
					$msg .= sprintf("error" . _("Fehler bei setSeminar fr %s .") . "", $new_semid);
				if(!$this->setSeminarSemTree($val->seminar_sem_tree)==1)
					$msg .= sprintf("error" . _("Fehler bei setSeminarSemTree fr %s .") . "", $new_semid);
				if(!$this->setDozenten($val->dozent)==1)
					$msg .= sprintf("error" . _("Fehler bei setDozenten fr %s .") . "", $new_semid);
				if(!$this->setSeminarInst($val->seminar_inst)==1)
					$msg .= sprintf("error" . _("Fehler bei setSeminarInst fr %s .") . "", $new_semid);
				foreach ($val->generic as $key2 => $val2) {
					if(!$this->setGeneric($val2)==1)
						$msg .= sprintf("error" . _("Fehler bei setGeneric fr %s .") . "", $new_semid);
				}
		}

			$semObj = Seminar::getInstance($new_semid);
			foreach ($semObj->getCycles() as $cycle_id => $cycle) {
				$semObj->getSingleDatesForCycle($cycle_id);
			}
			
			return $msg;
		}
		
		
}

?>
